vsg: vsg::Context Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::Context Class Reference

`#include <Context.h>`

Inheritance diagram for vsg::Context:
[legend]
Collaboration diagram for vsg::Context:
[legend]

## Public Member Functions
| Context (Device *in_device, const ResourceRequirements &in_resourceRequirements={})
| Context (const Context &context)
ShaderCompiler * | getOrCreateShaderCompiler ()
| get existing ShaderCompiler or create a new one when GLSLang is supported
ref_ptr< CommandBuffer > | getOrCreateCommandBuffer ()
void | reserve (const ResourceRequirements &requirements)
| reserve resources that may be needed during compile traversal.
ref_ptr< DescriptorSet::Implementation > | allocateDescriptorSet (DescriptorSetLayout *descriptorSetLayout)
void | copy (ref_ptr< Data > data, ref_ptr< ImageInfo > dest)
void | copy (ref_ptr< Data > data, ref_ptr< ImageInfo > dest, uint32_t numMipMapLevels)
void | copy (ref_ptr< BufferInfo > src, ref_ptr< BufferInfo > dest)
bool | record ()
| return true if there are commands that have been submitted
void | waitForCompletion ()
Public Member Functions inherited from vsg::Inherit< Object, Context >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
const uint32_t | deviceID = 0
ref_ptr< Device > | device
ResourceRequirements | resourceRequirements
observer_ptr< View > | view
uint32_t | viewID = 0
Mask | mask = MASK_ALL
ViewDependentState * | viewDependentState = nullptr
ref_ptr< RenderPass > | renderPass
GraphicsPipelineStates | defaultPipelineStates
GraphicsPipelineStates | overridePipelineStates
ref_ptr< DescriptorPools > | descriptorPools
ref_ptr< ShaderCompiler > | shaderCompiler
ref_ptr< Instrumentation > | instrumentation
| Hook for assigning Instrumentation to enable profiling.
ref_ptr< Queue > | graphicsQueue
ref_ptr< CommandPool > | commandPool
ref_ptr< CommandBuffer > | commandBuffer
ref_ptr< Fence > | fence
ref_ptr< Semaphore > | semaphore
ref_ptr< ScratchMemory > | scratchMemory
bool | requiresWaitForCompletion = false
std::vector< ref_ptr< Command > > | commands
ref_ptr< CopyAndReleaseImage > | copyImageCmd
ref_ptr< CopyAndReleaseBuffer > | copyBufferCmd
ref_ptr< MemoryBufferPools > | deviceMemoryBufferPools
ref_ptr< MemoryBufferPools > | stagingMemoryBufferPools
VkDeviceSize | scratchBufferSize
std::vector< ref_ptr< BuildAccelerationStructureCommand > > | buildAccelerationStructureCommands
ref_ptr< TransferTask > | transferTask

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, Context >
static ref_ptr< Context > | create (Args &&... args)
static ref_ptr< Context > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

Context manages details about Device, View or other state during compile traversal. The CompileTraversal uses the Device as it traverses the scene graph creating Vulkan objects and transferring any data to the GPU

The documentation for this class was generated from the following file:

- include/vsg/vk/Context.h